/*  Programm  C10_2.c  */
/*  Demonstration von Addressen und Zeigern (Pointers)  */

#include <stdio.h>

main ()
  {
    int a, b;                    /*  klassische integer Variablen  */
    int *pa, *pb;               /*  Zeiger (Pointers) auf integer  */
    unsigned int ppa;           /*  Hilfsvariable fr die Ausgabe  */

    a = 25;                                   /*  Wertzuweisungen  */ 
    b = 43;

    pa = &a;                                /*  Adresszuweisungen  */
    pb = &b;
    ppa = &pa;
    
    printf ("\n\t  ADRESSEN, ZEIGER UND INHALTE VON DATENOBJEKTEN \n");
    printf ("\n  Adresse von  a = %x ,", &a); 
    printf ("    Zeiger auf  a  beinhaltet:  %x ,", pa); 
    printf ("\n  Wert    von  a = %d ,",  a);
    printf ("    Wert  von  *pa = %d ",  *pa);
    printf ("\n  Adresse von  b = %x ,", &b); 
    printf ("    Zeiger auf  b  beinhaltet:  %x ,", pb); 
    printf ("\n  Wert    von  b = %d ,",  b);
    printf ("    Wert  von  *pb = %d ",  *pb);
    printf ("\n  Variable  ppa  beinhaltet die Adresse von pa  =  %x \n", ppa);
    
    *pa = 120;                      /*  Neuer Wert der Variable  a  */

    printf ("\n  Adresse von  a = %x ,", &a); 
    printf ("    Zeiger auf  a  beinhaltet:  %x ,", pa); 
    printf ("\n  Wert    von  a = %d ,",  a);
    printf ("    Wert  von  *pa = %d \n",  *pa);

    (*pa)--;                                  /*  Dekrement von  a  */

    printf ("\n  Adresse von  a = %x ,", &a); 
    printf ("    Zeiger auf  a  beinhaltet:  %x ,", pa); 
    printf ("\n  Wert    von  a = %d ,",  a);
    printf ("    Wert  von  *pa = %d \n",  *pa);

    *pa--;                  /*  Dekrement des Zeigers (der Adresse) */

    printf ("\n  Adresse von  a = %x ,", &a); 
    printf ("    Zeiger auf  a  beinhaltet:  %x ,", pa); 
    printf ("\n  Wert    von  a = %d ,",  a);
    printf ("    Wert  von  *pa = %d ",  *pa);
    printf ("\n\n");
  }